setlocal

set VERSION=openssl-3.1.0

set CFG_FLAG=%1%

set ARCH=%2%
set COMP=%3%

if defined ARCH set ARCH=-%ARCH%
if defined COMP set COMP=-%COMP%

if %CFG_FLAG%==VC-WIN64A set EXISTING_DLL_SUFFIX=-x64

set SUFFIX=%ARCH%%COMP%

mkdir include
mkdir include\openssl
mkdir lib
mkdir lib\dll
mkdir lib\dll\debug
mkdir lib\static
mkdir lib\static\debug

cd %VERSION%

rem goto ReleaseStatic

:DebugStatic

perl Configure %CFG_FLAG% --debug --openssldir=C:\ThirdPartyPackages\OpenSSL\%VERSION%\SSL --prefix=c:\ThirdPartyPackages\OpenSSL\%VERSION% no-shared

REM Change names of libs and pdbs

ssed -e s/libcrypto.lib/libcrypto%SUFFIX%.lib/g makefile | ssed -e s/libssl.lib/libssl%SUFFIX%.lib/g | ssed -e s/Fdossl_static/Fdossl_static%SUFFIX%/g > makefile.processed

copy makefile makefile.old
copy makefile.processed makefile

nmake -f makefile clean
nmake -f makefile

xcopy include\openssl ..\include\openssl /Y

xcopy libcrypto%SUFFIX%.lib ..\lib\static\debug /Y
xcopy libssl%SUFFIX%.lib ..\lib\static\debug /Y
xcopy ossl_static%SUFFIX%.pdb ..\lib\static\debug /Y

nmake -f makefile clean

copy makefile.old makefile

rem rem goto End
:ReleaseStatic

perl Configure %CFG_FLAG% --openssldir=C:\ThirdPartyPackages\OpenSSL\%VERSION%\SSL --prefix=c:\ThirdPartyPackages\OpenSSL\%VERSION% no-shared

rem - already has /O2 - favor speed
rem /GL - whole program optimisation
rem /Oy - omit frame pointers
rem /Ob2 - any suitable inline expansion
rem /Oi - enable intrinsics
rem /Ot - favor fast code

rem /Oy - function level linking
rem /GM- - no minimal rebuild
rem /GF - string pooling
rem /Zi - program db

rem perl Configure %CFG_FLAG% --openssldir=C:\ThirdPartyPackages\OpenSSL\%VERSION%\SSL --prefix=c:\ThirdPartyPackages\OpenSSL\%VERSION% no-shared /GL /Oy /Ob2 /Oi /Ot

rem perl Configure %CFG_FLAG% --openssldir=C:\ThirdPartyPackages\OpenSSL\%VERSION%\SSL --prefix=c:\ThirdPartyPackages\OpenSSL\%VERSION% no-shared /Oy /Ob2 /Oi /Ot /GL /Oy /GM /GF /Zi

REM Change names of libs and pdbs

ssed -e s/libcrypto.lib/libcrypto%SUFFIX%.lib/g makefile | ssed -e s/libssl.lib/libssl%SUFFIX%.lib/g | ssed -e s/Fdossl_static/Fdossl_static%SUFFIX%/g > makefile.processed

copy makefile makefile.old
copy makefile.processed makefile

nmake -f makefile clean
nmake -f makefile

xcopy libcrypto%SUFFIX%.lib ..\lib\static /Y
xcopy libssl%SUFFIX%.lib ..\lib\static /Y
xcopy ossl_static%SUFFIX%.pdb ..\lib\static /Y

nmake -f makefile clean

copy makefile.old makefile

rem goto End

:DebugDLL

perl Configure %CFG_FLAG% --debug --openssldir=C:\ThirdPartyPackages\OpenSSL\%VERSION%\SSL --prefix=c:\ThirdPartyPackages\OpenSSL\%VERSION%

REM Change names of libs and pdbs

ssed -e s/libcrypto.lib/libcrypto%SUFFIX%.lib/g makefile | ssed -e s/libssl.lib/libssl%SUFFIX%.lib/g | ssed -e s/libcrypto-1_1%EXISTING_DLL_SUFFIX%/libcrypto-1_1%SUFFIX%/g | ssed -e s/libssl-1_1%EXISTING_DLL_SUFFIX%/libssl-1_1%SUFFIX%/g > makefile.processed

copy makefile makefile.old
copy makefile.processed makefile

nmake -f makefile clean
nmake -f makefile

xcopy libcrypto-1_1%SUFFIX%.lib ..\lib\dll\debug /Y
xcopy libcrypto-1_1%SUFFIX%.dll ..\lib\dll\debug /Y
xcopy libcrypto-1_1%SUFFIX%.pdb ..\lib\dll\debug /Y
xcopy libssl-1_1%SUFFIX%.lib ..\lib\dll\debug /Y
xcopy libssl-1_1%SUFFIX%.dll ..\lib\dll\debug /Y
xcopy libssl-1_1%SUFFIX%.pdb ..\lib\dll\debug /Y

nmake -f makefile clean

copy makefile.old makefile

:ReleaseDLL

perl Configure %CFG_FLAG% --openssldir=C:\ThirdPartyPackages\OpenSSL\%VERSION%\SSL --prefix=c:\ThirdPartyPackages\OpenSSL\%VERSION%

REM Change names of libs and pdbs

ssed -e s/libcrypto.lib/libcrypto%SUFFIX%.lib/g makefile | ssed -e s/libssl.lib/libssl%SUFFIX%.lib/g | ssed -e s/libcrypto-1_1%EXISTING_DLL_SUFFIX%/libcrypto-1_1%SUFFIX%/g | ssed -e s/libssl-1_1%EXISTING_DLL_SUFFIX%/libssl-1_1%SUFFIX%/g > makefile.processed

copy makefile makefile.old
copy makefile.processed makefile

nmake -f makefile clean
nmake -f makefile

xcopy libcrypto-1_1%SUFFIX%.lib ..\lib\dll /Y
xcopy libcrypto-1_1%SUFFIX%.dll ..\lib\dll /Y
xcopy libcrypto-1_1%SUFFIX%.pdb ..\lib\dll /Y
xcopy libssl-1_1%SUFFIX%.lib ..\lib\dll /Y
xcopy libssl-1_1%SUFFIX%.dll ..\lib\dll /Y
xcopy libssl-1_1%SUFFIX%.pdb ..\lib\dll /Y

nmake -f makefile clean

:End

cd ..
